<!--
 * @Author: @liulin
 * @Date: 2022-06-02 15:30:29
 * @LastEditors: @liulin
-->
<template>
  <at-table
    @load="loadData"
    :data="data"
    :page-result="pageResult"
    ref="AtTable"
    :dialogTitle="dialogTitle"
    :dialogVisible="dialogVisible"
    @select-all="handleSelect"
    @select="handleSelect"
    @handleDialogCancel="handleDialogCancel"
    @handleDialogClose="handleDialogClose"
    @handleDialogSubmit="handleDialogSubmit"
    @row-dblclick="handleRowDBClick"
  >
    <template v-slot:searchInput>
      <el-form
        ref="searchForm"
        :model="searchForm"
        label-width="80px"
        class="search-top"
        @submit.native.prevent
      >
        <project-info-selector
          v-if="isShow"
          v-model="searchForm.projectId"
          style="width: 100%"
          @keyup.enter.native="findinfo"
        ></project-info-selector>
        <el-input
          v-model="searchForm.name"
          style="width: 100%"
          placeholder="请输入开工名称"
          clearable
          @keyup.enter.native="findinfo"
        ></el-input>
        <el-date-picker
          v-model="searchForm.startDate"
          type="date"
          placeholder="选择开工日期"
          value-format="yyyy-MM-dd"
          format="yyyy-MM-dd"
          style="width: 100%"
          @keyup.enter.native="findinfo"
        >
        </el-date-picker>
        <el-button
          size="small"
          @click="findinfo"
          type="primary"
          class="el-icon-search search-btn"
        >查询</el-button>
        <el-button
          size="small"
          @click="handleReset"
          type="primary"
          plain
          class="el-icon-refresh"
        >重置</el-button>
      </el-form>
    </template>
    <template v-slot:operationBtn>
      <el-button
        size="small"
        type="primary"
        @click="handleAdd"
        icon="el-icon-plus"
      >添加</el-button>
      <ht-delete-button
        :url="deleteUrl"
        :requestMethod="'POST'"
        :htTable="$refs.AtTable"
      >删除</ht-delete-button>
      <import-file
        :importData="importData"
        @load="load"
      ></import-file>
      <el-button
        size="small"
        type="primary"
        @click="handleExport"
        icon="el-icon-download"
        plain
        style="margin-left: 10px"
      >导出</el-button>
    </template>
    <template>
      <el-table-column
        type="selection"
        width="55"
        align="center"
      >
      </el-table-column>
      <el-table-column
        label="序号"
        type="index"
        width="55"
        align="center"
      >
      </el-table-column>
      <el-table-column
        prop="projectInfo.projectName"
        label="项目名称"
        :show-overflow-tooltip="true"
        align="center"
      >
      </el-table-column>
      <!-- <el-table-column
        prop="docunemtNumber"
        label="开工文号"
        align="center"
        width="160"
        :show-overflow-tooltip="true"
      >
      </el-table-column> -->

      <el-table-column
        prop="estimaneDate"
        label="审核日期"
        align="center"
        :show-overflow-tooltip="true"
      >
      </el-table-column>

      <!-- <el-table-column
        prop="mainEngineer"
        label="总监理工程师"
        align="center"
        width="160"
        :show-overflow-tooltip="true"
      >
      </el-table-column> -->
      <!-- <el-table-column
        prop="name"
        label="开工名称"
        align="center"
        width="150"
        :show-overflow-tooltip="true"
      >
      </el-table-column> -->
      <!-- <el-table-column
        prop="projectManager"
        label="施工单位负责人"
        align="center"
        width="150"
        :show-overflow-tooltip="true"
      >
      </el-table-column> -->
      <el-table-column
        prop="startDate"
        label="开工日期"
        align="center"
        :show-overflow-tooltip="true"
      >
      </el-table-column>
      <el-table-column
        prop="remarks"
        label="备注"
        align="center"
        width="120"
        :show-overflow-tooltip="true"
      >
      </el-table-column>
    </template>
    <template v-slot:dialogContent>
      <el-form
        ref="form"
        v-form
        data-vv-scope="form"
        :model="form"
        :rules="rules"
        label-width="130px"
        v-if="dialogVisible"
        v-loading.fullscreen="loading"
      >
        <el-row>
           <el-col :span="12">
            <el-form-item
              label="项目名称"
              prop="projectInfo.projectName"
            >
              <el-input
                v-model="form.projectInfo.projectName"
                placeholder="请选择项目名称"
                @focus="handleFocusProject"
                clearable
                :disabled="!isShow"
              >
                <el-button
                  type="primary"
                  @click="openProject"
                  slot="append"
                  icon="el-icon-search"
                ></el-button>
              </el-input>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item
              label="开工日期"
              prop="startDate"
            >
              <el-date-picker
                v-model="form.startDate"
                type="date"
                placeholder="选择开工日期"
                value-format="yyyy-MM-dd"
                format="yyyy-MM-dd"
                style="width: 100%"
              >
              </el-date-picker>
            </el-form-item>
          </el-col>
         
          <!-- <el-col :span="12">
            <el-form-item
              label="开工文号"
              prop="docunemtNumber"
            >

              <el-input
                v-model="form.docunemtNumber"
                placeholder="请输入开工文号"
                clearable
              ></el-input>
            </el-form-item>
          </el-col> -->
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item
              label="审核日期"
              prop="estimaneDate"
            >
              <el-date-picker
                v-model="form.estimaneDate"
                type="date"
                placeholder="选择审核日期"
                value-format="yyyy-MM-dd"
                format="yyyy-MM-dd"
                style="width: 100%"
              >
              </el-date-picker>
            </el-form-item>
          </el-col>
          <!-- <el-col :span="12">
            <el-form-item
              label="总监理工程师"
              prop="mainEngineer"
            >
              <el-input
                v-model="form.mainEngineer"
                placeholder="请输入总监理工程师"
                clearable
              />
            </el-form-item>
          </el-col> -->
        </el-row>
        <el-row>
          <!-- <el-col :span="12">
            <el-form-item
              label="开工名称"
              prop="name"
            >
              <el-input
                v-model="form.name"
                placeholder="请输入开工名称"
                clearable
              />
            </el-form-item>
          </el-col> -->
          <!-- <el-col :span="12">
            <el-form-item
              label="施工单位负责人"
              prop="projectManager"
            >
              <el-input
                v-model="form.projectManager"
                placeholder="请输入施工单位负责人"
                clearable
              />
            </el-form-item>
          </el-col> -->
        </el-row>
        <el-row>

        </el-row>
        <el-row>
          <el-col :span="24">
            <el-form-item
              label="备注"
              prop="remarks"
            >
              <el-input
                v-model="form.remarks"
                placeholder="请输入备注"
                type="textarea"
                clearable
              ></el-input>
            </el-form-item>
          </el-col>
        </el-row>
        <file-table
          @handleFile="handleFile"
          :file="form.accessoryInfo"
          :info='"上传项目开工等文件"'
        />
        <project-info-dialog
          ref="project"
          :single="true"
          @select="handleSelectProject"
        ></project-info-dialog>
      </el-form>
    </template>
  </at-table>
</template>

<script>
import req from '@/request.js'
import ProjectInfoDialog from '@/components/dialog/ProjectInfoDialog.vue'
export default {
  name: 'projectStart',
  components: {
    ProjectInfoDialog
  },
  props: {
    pid: {
      type: String,
      default: ''
    },
    isShow: {
      type: Boolean,
      default: true
    }
  },
  data() {
    return {
      importData: {
        title: '项目开工导入',
        templateName: '项目开工模板.xls',
        downloadUrl: '/../fvue/static/excel/project_start.xlsx',
        importUrl:
          window.context.cqxy + '/biz/project/start/v1/importExcelData',
        showProject: true,
        projectId: ''
      },
      projectObj: [],
      loading: false,
      searchForm: {
        projectId: '',
        name: '',
        startDate: ''
      }, //顶部搜索参数
      data: [], //表格数据
      pageResult: {
        page: 1,
        pageSize: 20,
        total: 0
      },
      form: {},
      dialogVisible: false,
      dialogTitle: '添加',
      indexArr: [],
      querySearch: [],
      rules: {
        'projectInfo.projectName': {
          required: true,
          message: '请选择项目名称',
          trigger: 'blur'
        },
        startDate: {
          required: true,
          message: '请选择开工时间',
          trigger: 'blur'
        }
      }
    }
  },
  computed: {
    deleteUrl: function() {
      return window.context.cqxy + '/biz/project/start/v1/delete'
    }
  },
  mounted() {
    this.initProjectAll()
  },
  methods: {
    //重置
    handleReset() {
      this.searchForm.projectId = ''
      this.searchForm.name = ''
      this.searchForm.startDate = ''
      this.$refs['searchForm'].resetFields()
      this.pageResult = {
        page: 1,
        pageSize: 20,
        total: 0
      }
      this.$nextTick(() => {
        this.$refs.AtTable.load()
      })
    },
    //导入后重新加载数据
    load() {
      this.$refs.AtTable.load()
    },
    //导出
    handleExport() {
      let query = []
      let search = {
        project_id_: this.searchForm.projectId,
        name_: this.searchForm.name,
        start_date_: this.searchForm.startDate
      }
      if (!this.isShow) {
        search['pm.ID_'] = this.pid
      }
      for (let i in search) {
        if (search[i]) {
          query.push({
            group: 'advance',
            operation: 'LIKE',
            property: i,
            relation: 'AND',
            value: search[i]
          })
        }
      }
      let param = {
        pageBean: {
          page: 1,
          pageSize: -1,
          showTotal: true
        },

        querys: query,
        sorter: []
      }
      req
        .downloadPostCopy(
          '${cqxy}/biz/project/start/v1/exportDataToExcel',
          param
        )
        .then(res => {
          if (res.status === 200) {
            this.$message.success('导出成功')
          } else {
            this.$message.error('导出失败')
          }
        })
    },
    handleFile(file) {
      this.form.accessoryInfo = file
    },
    handleAdd() {
      this.dialogTitle = '添加'
      this.form = {
        name: '', //重庆西永微电子产业园区开发有限公司
        estimaneDate: this.getDate(),
        startDate: this.getDate(),
        projectInfo: {
          projectName: '',
          projectCode: ''
        },
        accessoryInfo: [],
        proposedLocation: ''
      }
      this.dialogVisible = true
      if (this.isShow) {
        let selectedProject = this.projectObj.find(item => {
          if (item.currentProject && item.currentProject == 1) {
            return item.currentProject == 1
          }
        })
        this.form.projectInfo.projectName = selectedProject.projectName
        this.form.projectInfo.projectCode = selectedProject.projectCode
        this.form.projectId = selectedProject.id
        this.form.proposedLocation = selectedProject.projectAddress
      } else {
        //根据项目id查询
        this.form.projectInfo.projectName = this.projectObj[0].projectName
        this.form.projectInfo.projectCode = this.projectObj[0].projectCode
        this.form.projectId = this.projectObj[0].id
        this.form.proposedLocation = this.projectObj[0].projectAddress
      }
    },
    handleRowDBClick(data) {
      this.dialogTitle = '修改'
      // let time = data.contractDuration
      // if (time) {
      //   this.form.contractDuration = time.split('~')
      // }

      this.form = data
      this.dialogVisible = true
    },
    handleFocusProject() {
      this.$refs.project.open()
    },
    openProject() {
      this.$refs.project.open()
    },
    handleSelectProject(data) {
      this.form.projectId = data.id
      this.form.projectInfo.projectCode = data.projectCode
      this.form.projectInfo.projectName = data.projectName
      this.form.proposedLocation = data.projectAddress
      this.$refs.form.clearValidate()
    },
    handleSelect(selection) {},
    handleDialogCancel() {
      this.dialogVisible = false
    },
    handleDialogClose() {
      this.dialogVisible = false
    },
    initProjectAll() {
      //初始获取所有项目数据
      if (this.isShow) {
        this.$http.post('${cqxy}/biz/projectManagement/pm/v1/All').then(
          res => {
            this.projectObj = res.data.value
          },
          error => {
            reject(error)
          }
        )
      } else {
        let params = {
          pageBean: {
            page: 1,
            pageSize: 500,
            total: 0
          },
          querys: [
            {
              group: 'main',
              operation: 'EQUAL',
              property: 'id',
              relation: 'AND',
              value: this.pid
            }
          ]
        }
        this.$http
          .post('${cqxy}/biz/projectManagement/pm/v1/page', params)
          .then(res => {
            if (res.data.state) {
              let resp = res.data.value
              this.projectObj = resp.rows
            }
          })
      }
    },
    //提交保存
    handleDialogSubmit() {
      this.$refs.form.validate(valid => {
        //&& this.form.accessoryInfo.length !== 0
        if (valid) {
          if (this.form.accessoryInfo && this.form.accessoryInfo.length) {
            this.form.accessoryInfo.forEach(item => {
              if (item.id) {
                delete item.id
              }
            })
          }
          this.loading = true
          delete this.form.projectName
          delete this.form.projectCode
          // let time = this.form.contractDuration
          // if (typeof time == 'object') {
          //   this.form.contractDuration = time.join('~')
          // }
          this.$http
            .post('${cqxy}/biz/project/start/v1/save', this.form)
            .then(res => {
              if (res.status == 200) {
                this.$refs.form.resetFields()
                this.$message.success(res.data.message)
                this.dialogVisible = false
                this.$refs.AtTable.load()
              } else {
                this.$message.error(res.data.message)
              }
              this.loading = false
            })
        } else {
          this.$message({
            message: '*号必填项,不能为空!',
            type: 'warning'
          })
          return false
        }
        // else if (this.form.accessoryInfo.length === 0) {
        //   this.$message.error('请至少上传一个附件')
        // }
      })
    },
    //查询
    findinfo() {
      this.$refs.AtTable.load()
    },
    loadData(param, cb) {
      let query = []
      let search = {
        project_id_: this.searchForm.projectId,
        name_: this.searchForm.name,
        start_date_: this.searchForm.startDate
      }
      if (!this.isShow) {
        search['project_id_'] = this.pid
        this.importData.projectId = this.pid
      }
      for (let i in search) {
        if (search[i]) {
          query.push({
            group: 'advance',
            operation: 'LIKE',
            property: i,
            relation: 'AND',
            value: search[i]
          })
        }
      }
      if (param.querys && param.querys.length) {
        param.querys.push(...query)
      } else {
        param.querys = query
      }
      this.$http
        .post('${cqxy}/biz/project/start/v1/page', param)
        .then(
          resp => {
            let response = resp.data.value
            this.data = response.rows
            this.pageResult = {
              page: response.page,
              pageSize: response.pageSize,
              total: response.total
            }
          },
          error => {
            reject(error)
          }
        )
        .finally(() => cb())
    }
  }
}
</script>
<style lang="scss" scoped>
@import '@/assets/css/common.scss';
/deep/ .el-range-editor--small .el-range-separator {
  display: contents;
}
</style>
